;*******************************************************************************
;                      MultiExe.asm 
;     pic16F84,   
;        
;               http://www.mbit.h15.ru/ 
;
;         ***     by BDA Hardware  ***
;         ***               BDA2005@km.ru                ***
;
;               PIC16F84       32.768 .
;===============================================================================
            LIST        p=16F84     ;   .
            __CONFIG    _CP_OFF & _WDT_OFF & _LP_OSC & _PWRTE_ON
                        ;   , WDT , 
                        ; : Low Power Crystal (32768Hz)
                        ; Power-up Timer 
;===============================================================================
;         .
;===============================================================================
            #include   "P16F84.INC" ; Include header file

;===============================================================================
;             .
;===============================================================================
;   Sec     
;===============================================================================
Sec         equ         0Ch         ;   Sec.
dtmr        equ         0Dh         ;   / Pause
Err         equ         0Eh         ;    :
                                    ; (7 =1 =>   )
                                    ; (6 =1 =>   )
                                    ; (0 =1 => )
;===============================================================================
;      
;===============================================================================
;
; RB-0>        
; RB-7>        
;            
; RB-1>         
; RB-2>         
; RB-3>         
; RB-4>        
; RB-5>    (-)  
; RB-6>          
;
; RA-2>   ",  " []
; RA-3>   " " []
; RA-4>    (=0 =>  )
;
;===============================================================================
            ORG         0            ;      0 PC.
            goto        init         ;    Start.
            ORG         4
            retfie

;*******************************************************************************
;                             .
;*******************************************************************************
init        bsf       STATUS,RP0     ;   1-  (  1 5- 
                                     ;  STATUS).
            MOVLW     B'00000011'    ;   , =16 ...011,
            MOVWF     OPTION_REG     ;   ,  .

            MOVLW     B'00011111'    ; RA0-RA4 -.
            MOVWF     TRISA

            MOVLW     B'01000001'    ; RB0..,  , RB1-RB7-.
            MOVWF     TRISB

            bcf       STATUS,RP0     ;   0-  (  0 5- 
                                     ;  STATUS).


            clrf      PORTB
main
            clrf      INTCON         ;  ,  
;-------------------------------------------------------------------------------
; 2.   .   0.5  , 4.5  
;-------------------------------------------------------------------------------

wait
            movlw     b'00000000'  ; 
            movwf     PORTB
            call      Pause05
            movlw     b'00000000'  ;  
            movwf     PORTB
            movlw     .9           ; 9*0.5 = 4.5 
            movwf     Sec
wait1       call      Pause05

            btfsc     INTCON,INTF  ;  INTF=1,
            goto      start        ;      start

            decfsz    Sec, f
            goto      wait1

            goto      wait


;-------------------------------------------------------------------------------
;    
;-------------------------------------------------------------------------------

start
            clrf	TMR0       ;    
            btfss      PORTB,6     ;     0-   PORTB  0,   -
                                   ;   (goto OFF),    1,  
                                   ;    ( - nop)  
                                   ;    btfsc     PORTA,4
            goto        wait
            call        Prodyvka
            call        Rozgyig
            call        Rabota1
            call        Rabota2
            call        Rabota3
            goto        start

;-------------------------------------------------------------------------------
;  
;-------------------------------------------------------------------------------
Prodyvka

           movlw     b'00010000'    ;   ,    3 
           movwf     PORTB          ;     
            movlw       .3           ;    W   Sec = 30  = 0.5 
            movwf       Sec
            call      Pause
           btfsc      PORTA,3     ;     3-   PORTA  1,   -
                                   ;   (goto Prodyvka),    0,  
                                   ;    ( - nop)  
                                   ;    btfss      PORTB,0
            goto        Prodyvka
            btfss      PORTB,6     ;     0-   PORTB  0,   -
                                   ;   (goto OFF),    1,  
                                   ;    ( - nop)  
                                   ;    btfsc     PORTA,4
            goto        OFF

            return
;-------------------------------------------------------------------------------
;   
;-------------------------------------------------------------------------------
OFF
           clrf		TMR0            ;    
           movlw     b'00000000'    ;   , 
           movwf     PORTB          ;     

           call          wait
           
;-------------------------------------------------------------------------------
;  
;-------------------------------------------------------------------------------


Rozgyig
           btfsc      PORTA,3     ;     3-   PORTA  1,   -
                                   ;   (goto Prodyvka),    0,  
                                   ;    ( - nop)  
                                   ;    btfss      PORTB,0
            goto        Prodyvka

           movlw     b'00100010'    ;   ,   (  )   
           movwf     PORTB          ;        
            movlw       .1           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
            btfss      PORTB,6     ;     6-   PORTB  0,   -
                                   ;   (goto OFF),    1,  
                                   ;    ( - nop)  
                                   ;    btfsc     PORTA,4
           goto        Prodyvka

            btfss      PORTA,4     ;    4-   PORTA  0,   -
                                   ;   (goto Rozgyig),    1,  
                                   ;    ( - nop)  
                                   ;      goto  p05
          goto Rozgyig
          goto        Rabota1

            return
;-------------------------------------------------------------------------------
;    
;-------------------------------------------------------------------------------
Rabota1
           btfsc      PORTA,3     ;     3-   PORTA  1,   -
                                   ;   (goto Prodyvka),    0,  
                                   ;    ( - nop)  
                                   ;    btfss      PORTB,0
            goto        Prodyvka
            btfss      PORTB,6     ;     0-   PORTB  0,   -
                                   ;   (goto OFF),    1,  
                                   ;    ( - nop)  
                                   ;    btfsc     PORTA,4
           goto        Prodyvka

            btfss      PORTA,4     ;    4-   PORTA  0,   -
                                   ;   (goto Rozgyig),    1,  
                                   ;    ( - nop)  
                                   ;      goto  p05
          goto Rozgyig

           movlw     b'00000100'    ;       
           movwf     PORTB          ;        
            movlw       .1           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
          btfsc      PORTA,0     ;    1-   0-   PORTA  1,   -
                                   ;   (goto Rabota1),    0,  
                                   ;    ( - nop)  
                                   ;     btfsc      PORTA,1
          goto        Rabota1
          btfsc      PORTA,1     ;    2-   1-   PORTA  1,   -
                                   ;   (goto Rabota2),    0,  
                                   ;    ( - nop)  
                                   ;      btfsc  PORTA,2
            goto        Rabota2
            goto        Rabota2
          btfsc      PORTA,2     ;    3-   2-   PORTA  1,   -
                                   ;   (goto Rabota3),    0,  
                                   ;    ( - nop)  
                                   ;      return
            goto        Rabota3
            goto        Rabota2
            return
;-------------------------------------------------------------------------------
;    
;-------------------------------------------------------------------------------
Rabota2
           btfsc      PORTA,3     ;     3-   PORTA  1,   -
                                   ;   (goto Prodyvka),    0,  
                                   ;    ( - nop)  
                                   ;    btfss      PORTB,0
            goto        Prodyvka
            btfss      PORTB,6     ;     0-   PORTB  0,   -
                                   ;   (goto OFF),    1,  
                                   ;    ( - nop)  
                                   ;    btfsc     PORTA,4
           goto        Prodyvka

            btfss      PORTA,4     ;    4-   PORTA  0,   -
                                   ;   (goto Rozgyig),    1,  
                                   ;    ( - nop)  
                                   ;      goto  p05
          goto Rozgyig


           movlw     b'00001000'    ;      
           movwf     PORTB          ;        
            movlw       .1           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause

          btfsc      PORTA,0     ;    1-   0-   PORTA  1,   -
                                   ;   (goto Rabota1),    0,  
                                   ;    ( - nop)  
                                   ;     btfsc      PORTA,1
          goto        Rabota1
          btfsc      PORTA,1     ;    2-   1-   PORTA  1,   -
                                   ;   (goto Rabota2),    0,  
                                   ;    ( - nop)  
                                   ;      btfsc  PORTA,2
            goto        Rabota2
          btfsc      PORTA,2     ;    3-   2-   PORTA  1,   -
                                   ;   (goto Rabota3),    0,  
                                   ;    ( - nop)  
                                   ;      return
            goto        Rabota3
            goto        Rabota1
            return

;-------------------------------------------------------------------------------
;   3- 
;-------------------------------------------------------------------------------
Rabota3
           btfsc      PORTA,3     ;     3-   PORTA  1,   -
                                   ;   (goto Prodyvka),    0,  
                                   ;    ( - nop)  
                                   ;    btfss      PORTB,0
            goto        Prodyvka
            btfss      PORTB,6     ;     0-   PORTB  0,   -
                                   ;   (goto OFF),    1,  
                                   ;    ( - nop)  
                                   ;    btfsc     PORTA,4
           goto        Prodyvka

            btfss      PORTA,4     ;    4-   PORTA  0,   -
                                   ;   (goto Rozgyig),    1,  
                                   ;    ( - nop)  
                                   ;      goto  p05
          goto Rozgyig

           movlw     b'10010000'    ;    3- 
           movwf     PORTB          ;        
            movlw       .1           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
          btfsc      PORTA,2     ;    3-   2-   PORTA  1,   -
                                   ;   (goto Rabota3),    0,  
                                   ;    ( - nop)  
                                   ;      return
            goto        Rabota3
            goto        Rabota2
          btfsc      PORTA,0     ;    1-   0-   PORTA  1,   -
                                   ;   (goto Rabota1),    0,  
                                   ;    ( - nop)  
                                   ;     btfsc      PORTA,1
         
          goto        Rabota2
          goto        Rabota1
          btfsc      PORTA,1     ;    2-   1-   PORTA  1,   -
                                   ;   (goto Rabota2),    0,  
                                   ;    ( - nop)  
                                   ;      btfsc  PORTA,2
            goto        Rabota2

            return
;-----------------------------------------------------------------------------------
;     10     - Sec   
;-----------------------------------------------------------------------------------
Pause      movlw	.20	; 20*0.5=10
           movwf 	dtmr
p1         call		Pause05

           decfsz	dtmr, f
           goto		p1

           decfsz	Sec, f 
           goto		Pause
           return
;-------------------------------------------------------------------------------
;  0.5  
;-------------------------------------------------------------------------------
Pause05
           clrf		TMR0            ;    
           bcf		INTCON, T0IF	;    
           nop
           nop
           nop
       
p05b       btfss 	INTCON, T0IF	;    (0.5 )

           goto		p05b
           return

;*******************************************************************************                        
            end                     ;    ( 
                                    ;  ).                              
