;*******************************************************************************
;                      MultiExe.asm 
;     pic16F84,   
;        
;               http://www.mbit.h15.ru/ 
;
;         ***     by BDA Hardware  ***
;         ***               BDA2005@km.ru                ***
;
;               PIC16F84       32.768 .
;===============================================================================
            LIST        p=16F84     ;   .
            __CONFIG    _CP_OFF & _WDT_OFF & _LP_OSC & _PWRTE_ON
                        ;   , WDT , 
                        ; : Low Power Crystal (32768Hz)
                        ; Power-up Timer 
;===============================================================================
;         .
;===============================================================================
            #include   "P16F84.INC" ; Include header file

;===============================================================================
;             .
;===============================================================================
;   Sec     
;===============================================================================
Sec         equ         0Ch         ;   Sec.
dtmr        equ         0Dh         ;   / Pause
Err         equ         0Eh         ;    :
                                    ; (7 =1 =>   )
                                    ; (6 =1 =>   )
                                    ; (0 =1 => )
;===============================================================================
;      
;===============================================================================
;
; RB-0>        
; RB-7>        
;            
; RB-1>         
; RB-2>         
; RB-3>         
; RB-4>        
; RB-5>    (-)  
; RB-6>          
;
; RA-2>   ",  " []
; RA-3>   " " []
; RA-4>    (=0 =>  )
;
;===============================================================================
            ORG         0            ;      0 PC.
            goto        init         ;    Start.
            ORG         4
            retfie

;*******************************************************************************
;                             .
;*******************************************************************************
init        bsf       STATUS,RP0     ;   1-  (  1 5- 
                                     ;  STATUS).
            MOVLW     B'00000011'    ;   , =16 ...011,
            MOVWF     OPTION_REG     ;   ,  .

            MOVLW     B'00011111'    ; RA0-RA4-.
            MOVWF     TRISA

            MOVLW     B'00000000'    ; RB0_-,RB7 .
            MOVWF     TRISB

            bcf       STATUS,RP0     ;   0-  (  0 5- 
                                     ;  STATUS).
            clrf      PORTB
main
            clrf      INTCON         ;  ,  


;-------------------------------------------------------------------------------
;    
;-------------------------------------------------------------------------------

start
call      Rabota_R
;-------------------------------------------------------------------------------
Rabota_R
           btfss      PORTA,0     ;       0-   PORTA  0,   -
                                   ;   (goto Rabota1),    1,  
                                   ;    ( - nop)  
                                   ;     btfss    movlw     b'00011000' 
            goto        Rabota1
            movlw     b'00011000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .37           ;    W   Sec = 30  = 0.9 
            movwf       Sec          ;  .xx  W   Sec.  

            call      Pause
            movlw     b'00000000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .37           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
            goto        Rabota_R
;-------------------------------------------------------------------------------
 Rabota1
          btfss      PORTA,1     ;    1-   0-   PORTA  0,   -
                                   ;   (goto Rabota2),    0,  
                                   ;    ( - nop)  
                                   ;       movlw     b'00011000
            goto        Rabota2
 movlw     b'00011000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .29           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  

            call      Pause
            movlw     b'00000000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .29           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
            goto        Rabota1
Rabota2

          btfss      PORTA,2     ;    2-   2-   PORTA  0,   -
                                   ;   (goto Rabota3),    1,  
                                   ;    ( - nop)  
                                   ;      movlw     b'00011000
            goto        Rabota3

            movlw     b'00011000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .21           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  

            call      Pause
            movlw     b'00000000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .21           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
            goto        Rabota2
Rabota3
          btfss      PORTA,3     ;    3-   3-   PORTA  0,   -
                                   ;   (goto Rabota3),    1,  
                                   ;    ( - nop)  
                                   ;      movlw     b'00011000
            goto        start

            movlw     b'00011000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .13           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  

            call      Pause
            movlw     b'00000000'    ;8   ,   
            movwf     PORTB          ;         

            movlw       .13           ;    W   Sec = 30  = 0.5 
            movwf       Sec          ;  .xx  W   Sec.  
            call      Pause
            goto        Rabota3


;-----------------------------------------------------------------------------------
;     1     - Sec   
;-----------------------------------------------------------------------------------
Pause      movlw	.1	; 20*0.5=1
           movwf 	dtmr
p1         call		Pause05

           decfsz	dtmr, f
           goto		p1

           decfsz	Sec, f 
           goto		Pause
           return
;-------------------------------------------------------------------------------
;  0.5  
;-------------------------------------------------------------------------------
Pause05    clrf		TMR0            ;    
           bcf		INTCON, T0IF	;    
p05       btfss 	INTCON, T0IF	;    (0.5 )

           goto		p05
           return
;*******************************************************************************                        
            end                     ;    ( 
                                    ;  ).                              
